\section{Dictionaries}
Like a list, a dictionary is a mutable collection of many values. But unlike indexes for lists, indexes for dictionaries can use many different data types, not just integers. Indexes for dictionaries are called keys, and a key with its associated value is called a key-value pair.

\begin{lstlisting}
myCat = {
	'size': 'fat',
	'color': 'gray',
	'disposition': 'loud'
}
myCat['size']
\end{lstlisting}

\paragraph{Dictionaries vs. Lists}
Unlike lists, items in dictionaries are unordered. The first item in a list named spam would be spam[0]. But there is no “first” item in a dictionary. While the order of items matters for determining whether two lists are the same, it does not matter in what order the key-value pairs are typed in a dictionary. Though dictionaries are not ordered, the fact that you can have arbitrary values for the keys allows you to organize your data in powerful ways.

\begin{lstlisting}
eggs = {'name': 'Zophie', 'species': 'cat', 'age': '8'} 
ham = {'species': 'cat', 'age': '8', 'name': 'Zophie'} 
eggs == ham # Output = True
\end{lstlisting}

\paragraph{The keys(), values(), and items() Methods}
There are three dictionary methods that will return list-like values of the dictionary’s keys, values, or both keys and values: keys(), values(), and items(). The values returned by these methods are not true lists: they cannot be modified and do not have an append() method. But these data types (dict\_keys, dict\_values, and dict\_items, respectively) can be used in for loops.

\begin{lstlisting}
spam = {'color': 'red', 'age': 42}
for v in spam.values():
	print(v)
# Output = red 42

for k in spam.keys():
	print(k)
#Output = color age

for i in spam.items():
	print(i)
#Output ('color', 'red') ('age', 42)

list(spam.keys())
#Output = ['color', 'age']
\end{lstlisting}

\paragraph{Checking whether a Key or Value Exists in a Dictionary}
Recall from the previous chapter that the in and not in operators can check whether a value exists in a list. You can also use these operators to see whether a certain key or value exists in a dictionary.

\begin{lstlisting}
spam = {'name': 'Zophie', 'age': 7}
'name' in spam.keys() # True
\end{lstlisting}

\paragraph{The get() Method}
It’s tedious to check whether a key exists in a dictionary before accessing that keys value. Fortunately, dictionaries have a get() method that takes two arguments: the key of the value to retrieve and a fallback value to return if that key does not exist.

\begin{lstlisting}
picnicItems = {'apples': 5, 'cups': 2}
'I am bringing ' + str(pcinicItems.get('cups', 0)) + ' cups.'
\end{lstlisting}

\paragraph{The setdefault() Method}
You’ll often have to set a value in a dictionary for a certain key only if that key does not already have a value. The setdefault() method offers a way to do this in one line of code. The first argument passed to the method is the key to check for, and the second argument is the value to set at that key if the key does not exist. If the key does exist, the setdefault() method returns the key’s value.

\begin{lstlisting}
spam = {'name': 'Pooka', 'age': 5} 
spam.setdefault('color', 'black') 
# returns 'black'
spam 
# {'color': 'black', 'age': 5, 'name': 'Pooka'} 
spam.setdefault('color', 'white')
# returns 'black'
spam
# returns {'color': 'black', 'age': 5, 'name': 'Pooka'}
\end{lstlisting}

\subsection{Pretty Printing}
If you import the pprint module into your programs, you’ll have access to the pprint() and pformat() functions that will “pretty print” a dictionary’s values. This is helpful when you want a cleaner display of the items in a dictionary than what print() provides.

\begin{lstlisting}
import pprint
pprint.pprint(some_dictionary)
\end{lstlisting}

\subsection{Nested Dictionaries and Lists}
Modeling a tic-tac-toe board was fairly simple: the board needed only a single dictionary value with nine key-value pairs. As you model more com- plicated things, you may find you need dictionaries and lists that contain other dictionaries and lists. Lists are useful to contain an ordered series of values, and dictionaries are useful for associating keys with values.

\begin{lstlisting}
allGuests = {'Alice': {'apples': 5, 'pretzels': 12},
		'Bob': {'ham sandwiches': 3, 'apples': 2},
		'Carol': {'cups': 3, 'apple pies': 1}
}
\end{lstlisting}